-- Init audio device
Sound.init()
local fnt = Font.load("app0:/font.ttf")
-- Init some colors
local white = Color.new(255, 255, 255)
local black = Color.new(0, 0, 0)
local yellow = Color.new(237, 229, 154)
local red = Color.new(255, 0, 0)
local grey = Color.new(47, 47, 47)
local oldpad = SCE_CTRL_CROSS

System.createDirectory("ux0:/data/NotesHEX")
-- List a directory
local scripts = System.listDirectory("ux0:/data/NotesHEX/")
local cur_dir = "ux0:/data/NotesHEX/"

local imgBack = Graphics.loadImage("app0:/bg.png")
local btnBack = Graphics.loadImage("app0:/back.png")
local btnNew = Graphics.loadImage("app0:/new.png")
local imgBattery = Graphics.loadImage("app0:/battery.png")
local imgHelp = Graphics.loadImage("app0:/gtop.png")
local imgTop = Graphics.loadImage("app0:/top.png")

local editing = false

-- Init a index
local i = 1
local snd = Sound.open("app0:/click.wav")
local delsnd = Sound.open("app0:/tearing.wav")
local flipsnd = Sound.open("app0:/flip.wav")
local delayTouch = 8.0

local hasTyped = false

local ret = "There are no notes.\n\nPress the + button to create your first note."

local fisrtrun = true

local textY	= 0

-- Main loop
while true do
	local x1,y1 = Controls.readTouch()
	
	if x1 ~= nil then
		-- Edit text area
		if x1>380 and y1>128 and hasTyped==false then
			if #scripts>0 then
				tmphandle = System.openFile(cur_dir .. scripts[i].name, FREAD)
				tmptxt = System.readFile(tmphandle, 1000)
				System.closeFile(tmphandle)
				Keyboard.show("Editing note", tmptxt, 1000, TYPE_DEFAULT, MODE_TEXT, OPT_MULTILINE)
				hasTyped=true
				editing=true
			end
		end
		-- NEW button
		if x1<80 and y1>466 and hasTyped==false then
			Sound.play(flipsnd, NO_LOOP)
			Keyboard.show("Type your note", "", 1000, TYPE_DEFAULT, MODE_TEXT, OPT_MULTILINE)
			hasTyped=true
		end
	end
	if delayTouch>0 then 
		delayTouch = delayTouch - 0.1
	end

	Graphics.initBlend()
	Screen.clear()
	Font.setPixelSizes(fnt, 23)
	
	Graphics.drawImage(0, 0, imgBack)

	-- Checking for keyboard status
	status = Keyboard.getState()
	if status ~= RUNNING and hasTyped == true then
		hasTyped = false
		if status == CANCELED then
			day_num, d, mn, y = System.getDate()
			h,m,s = System.getTime()
			ret = "" .. Keyboard.getInput()
			if editing==false then
				handle = System.openFile(cur_dir .. d  .. "-" .. mn .. "-" .. y .. "_" .. h .. m .. s .. ".txt", FCREATE)
			else
				handle = System.openFile(cur_dir .. scripts[i].name, FCREATE)
				editing=false
			end
			System.writeFile(handle, "" .. ret, string.len(ret))
			System.closeFile(handle)
		else
			ret = "You canceled the keyboard"
		end
		
		-- Terminating keyboard
		Keyboard.clear()
		dofile("app0:/index.lua")
	end
	
	-- Drawing main text on right screen
	Font.print(fnt, 380, 102+textY, ret, black)
	
	Graphics.drawImage(0, 0, imgTop)
	Graphics.drawImage(315, 7, imgHelp)
	th,tm,ts = System.getTime()
	Graphics.debugPrint(740, 6, string.format("%02d:%02d",th,tm), white)--Draw time
	life = System.getBatteryPercentage()
	Graphics.drawImage(912, 4, imgBattery)
	Graphics.fillRect(946, 946-(life/4), 10, 22, white)
	Graphics.debugPrint(850, 6, life .. "%", white)--Draw battery life
	
	local y = 60
	-- Write visible menu entries
	for j, file in pairs(scripts) do
		x = 5
		if j >= i and y < 960 then
			if i == j then
				Graphics.fillRect(0, 300, y-10, y+32, yellow)
				x = 10
			end
			Graphics.debugPrint(x, y, file.name, black)
			y = y + 32
		end
	end
	
	if #scripts>0 then
	Graphics.debugPrint(8, 6, "Note " .. i .. "/" .. #scripts, white)
		if fisrtrun==true then
			fisrtrun=false
			handle = System.openFile(cur_dir .. scripts[i].name, FREAD)
			ret = System.readFile(handle, 1000)
			System.closeFile(handle)
		end
	else
	Graphics.debugPrint(8, 6, "There are no notes.", red)
	ret = "There are no notes.\n\nPress the + button to create your first note."
	end
	
	Graphics.debugPrint(380, 520, "Notepad v1.0 by VitaHEX | www.patreon.com/vitahex", grey)
	Graphics.drawImage(0, 473, btnNew)

	Graphics.termBlend()
	
	-- Check for input
	pad = Controls.read()
	cx, cy = Controls.readRightAnalog()
		if cy < 64 then
			textY = textY - 2
		elseif cy > 180 then
			if textY<0 then
			textY = textY + 2
			end
		end
		
	if Controls.check(pad, SCE_CTRL_CROSS) and not Controls.check(oldpad, SCE_CTRL_CROSS) then
		--EDIT
		if hasTyped==false then
			if #scripts>0 then
				tmphandle = System.openFile(cur_dir .. scripts[i].name, FREAD)
				tmptxt = System.readFile(tmphandle, 1000)
				System.closeFile(tmphandle)
				Keyboard.show("Editing note", tmptxt, 1000, TYPE_DEFAULT, MODE_TEXT, OPT_MULTILINE)
				hasTyped=true
				editing=true
			end
		end
	elseif Controls.check(pad, SCE_CTRL_SQUARE) and not Controls.check(oldpad, SCE_CTRL_SQUARE) then
		--NEW
		if hasTyped==false then
			Sound.play(flipsnd, NO_LOOP)
			Keyboard.show("Type your note", "", 1000, TYPE_DEFAULT, MODE_TEXT, OPT_MULTILINE)
			hasTyped = true
		end
	elseif Controls.check(pad, SCE_CTRL_TRIANGLE) and not Controls.check(oldpad, SCE_CTRL_TRIANGLE) then
		--DELETE
		if  delayTouch<0.1 then
			Sound.play(delsnd, NO_LOOP)
			delayTouch=4
			System.deleteFile(cur_dir .. scripts[i].name)
			dofile("app0:/index.lua")
		end
	elseif Controls.check(pad, SCE_CTRL_UP) and not Controls.check(oldpad, SCE_CTRL_UP) then
		if #scripts>0 then
			textY = 0
			i = i - 1
			if i < 1 then
				i = #scripts
			end
			handle = System.openFile(cur_dir .. scripts[i].name, FREAD)
			ret = System.readFile(handle, 1000)
			System.closeFile(handle)
		end
	elseif Controls.check(pad, SCE_CTRL_DOWN) and not Controls.check(oldpad, SCE_CTRL_DOWN) then
		if #scripts>0 then
			textY = 0
			i = i + 1
			if i > #scripts then
				i = 1
			end
			handle = System.openFile(cur_dir .. scripts[i].name, FREAD)
			ret = System.readFile(handle, 1000)
			System.closeFile(handle)
		end
	end
	
	if i > #scripts then
		i = 1
	elseif i < 1 then
		i = #scripts
	end
	
	oldpad = pad
	Screen.flip()
end
